
#include "common.h"
#include "Console.h"
#include "Player.h"


Player player;

char PlayerShot = '|';	
char EnemyShot = '*';	

#define PLAYER_SHOT        0	
#define ENEMY_SHOT         1	

struct ShotInfo 
{
	int x, y;		
	int Type;		
	int UseFlag;
};

#define MAX_SHOT_COUNT      30						
struct ShotInfo            Shot[MAX_SHOT_COUNT];	

#define ENEMY_SIZE          3			
char EnemyUnit[ENEMY_SIZE + 1] = "@-@";

struct EnemyInfo 
{
	int x, y;		
	int LiveFlag;
	int StartX;		
	int MoveFlag;
};

#define MAX_ENEMY_COUNT      30			
struct EnemyInfo Enemy[MAX_ENEMY_COUNT];

void InitialObject(void);
void PlayerAction(void);
void DrawPlayer(void);
void Draw(void);
void EnemyAction(void);
void DrawEnemy(void);
void CreateShot(int Type, int x, int y);
void ShotAction(void);
void DrawShot(void);
void CheckCrush(void);
int CheckClear(void);
int CheckGameEnd(void);

int main(void)
{
	Initial();				//	ܼ ȭ â ʱȭ
	InitialObject();		//	Ʈ ʱȭ
	
	srand( (unsigned int)time(NULL) );

	while (1) 
	{
		PlayerAction();		//	÷̾ ̵
		EnemyAction();		//	ʹ ̵
		ShotAction();		//	÷̾&ʹ Ѿ ̵

		Draw();				//	Ʈ ܼȭ鿡 
		
		CheckCrush();		//	浹üũ
		
		//	   üũ
		if (CheckGameEnd()) 
			break;

		Sleep(100);
	}

	return 0;
}

void InitialObject(void)
{
	int x = 17;
	int y = 1;
	int i;

	for ( i = 0; i < MAX_ENEMY_COUNT; i++ ) 
	{
		if ( i % 10 == 0 ) 
		{
			x = 17;
			y++;
		}

		Enemy[i].x = x;			
		Enemy[i].y = y;			
		Enemy[i].LiveFlag = 1;
		Enemy[i].StartX = x;	
		Enemy[i].MoveFlag = 1;	

		x += ENEMY_SIZE + 1 + 1;
	}
	
	player.Init(39,19);		//	÷̾ ʱȭ

	for ( i = 0; i < MAX_SHOT_COUNT; i++ ) 
		Shot[i].UseFlag = 0;
}

void PlayerAction(void)
{
	//	PlayerAction  Լ ȣ
	player.PlayerAction();
}

void DrawPlayer(void)
{
	player.DrawPlayer();	//	÷̾  Լ ȣ
}

void Draw(void)
{
	int i;
	
	for ( i = 0; i < HEIGHT; i++ ) 
	{
		memset(Screen[i], ' ', WIDTH);	
		Screen[i][WIDTH - 1] = 0;		
	}
	
	DrawPlayer();
	
	DrawEnemy();		
	
	DrawShot();			

	for ( i = 0; i < HEIGHT; i++ ) 
	{
		MoveCursor(0, i);		
		printf( Screen[i] );	
	}
}

void EnemyAction(void)
{
	int i;

	for ( i = 0; i < MAX_ENEMY_COUNT; i++ ) 
	{
		if ( Enemy[i].LiveFlag ) 
		{
			if ( Enemy[i].MoveFlag )	Enemy[i].x++;
			else						Enemy[i].x--;
			
			if ( abs( Enemy[i].x - Enemy[i].StartX ) > 13 ) 
			{
				Enemy[i].y++;	
				Enemy[i].MoveFlag = !Enemy[i].MoveFlag;
			}
			if (rand() % 100 < 2) 
				CreateShot( ENEMY_SHOT, Enemy[i].x, Enemy[i].y );
		}
	}	
}

void DrawEnemy(void)
{
	int i, j;
	
	int x;		
	int y;	

	for ( i = 0; i < MAX_ENEMY_COUNT; i++ ) 
	{
		if ( Enemy[i].LiveFlag == 0 ) 
			continue;
		
		x = Enemy[i].x - ENEMY_SIZE / 2;
		y = Enemy[i].y;	

		if ( y < 0 || y >= HEIGHT ) 
			continue;
		
		for ( j = 0; j < ENEMY_SIZE; j++ ) 
		{
			if ( x >= 0 && x < WIDTH ) 
				Screen[y][x] = EnemyUnit[j];
			
			x++;
		}
	}
}

void CreateShot(int Type, int x, int y)
{
	int i;

	for ( i = 0; i < MAX_SHOT_COUNT; i++ ) 
	{
		if ( Shot[i].UseFlag == 0 ) 
		{
			Shot[i].x = x;
			Shot[i].y = y;
			Shot[i].Type = Type;
			Shot[i].UseFlag = 1;

			return;	
		}
	}
}

void ShotAction(void)
{
	int i;

	for ( i = 0; i < MAX_SHOT_COUNT; i++ ) 
	{
		if ( Shot[i].UseFlag ) 
		{
			if ( Shot[i].Type == PLAYER_SHOT ) 
			{
				Shot[i].y--;
				
				if ( Shot[i].y < 0 ) 
					Shot[i].UseFlag = 0;
			}
			else if (Shot[i].Type == ENEMY_SHOT) 
			{
				Shot[i].y++;
				
				if ( Shot[i].y >= HEIGHT ) 
					Shot[i].UseFlag = 0;
			}
		}
	}
}

void DrawShot(void)
{
	int i;

	for ( i = 0; i < MAX_SHOT_COUNT; i++ ) 
	{
		if ( Shot[i].UseFlag ) 
		{
			if ( Shot[i].Type == PLAYER_SHOT ) 
				Screen[Shot[i].y][Shot[i].x] = PlayerShot;
			else if ( Shot[i].Type == ENEMY_SHOT )  
				Screen[Shot[i].y][Shot[i].x] = EnemyShot;
		}
	}
}

void CheckCrush(void)
{
	int i, j;

	for ( i = 0; i < MAX_SHOT_COUNT; i++ ) 
	{ 
		if (Shot[i].UseFlag == 0) 
			continue;
		
		if ( Shot[i].Type == PLAYER_SHOT ) 
		{
			for ( j = 0; j < MAX_ENEMY_COUNT; j++ ) 
			{
				if ( Enemy[j].LiveFlag == 0 ) 
					continue;
				
				if ( Shot[i].x >= Enemy[j].x - ENEMY_SIZE / 2 &&
					 Shot[i].x <= Enemy[j].x + ENEMY_SIZE / 2 &&
					 Shot[i].y == Enemy[j].y ) 
				{
					Shot[i].UseFlag = 0;	
					Enemy[j].LiveFlag = 0;	
					break;
				}
			}
		}

		else if ( Shot[i].Type == ENEMY_SHOT ) 
		{
			//	÷̾ CollisionWithShot Լ Ѿ ǥ 
			//	浹 ߻ϸ Լ true Ѵ.
			if ( player.CollisionWithShot( Shot[i].x, Shot[i].y ) )
			{
				Shot[i].UseFlag = 0;		
			}
		}
	}
}

int CheckClear(void)
{
	int i;

	for ( i = 0; i < MAX_ENEMY_COUNT; i++ ) 
	{
		if ( Enemy[i].LiveFlag ) 
			return 0;
	}

	return 1;	
}

int CheckGameEnd(void)
{
	//	player  Լ ȣ
	if ( player.GetLiveFlag() == 0 ) 
	{
		system("cls");
		MoveCursor(36, 12);
		printf(" !!");
		Sleep(1000);

		return 1;	
	}
	
	if ( CheckClear() ) 
	{
		system("cls"); 
		MoveCursor(36, 12);
		printf(" ̰!!");
		Sleep(1000);

		return 1;	
	}
	
	return 0;
}